#include "ESC_Controller.h"
#include "main.h"

#define SLAVE_OWN_ADDRESS 0x52  //只用高7位
uint8_t dataSend[11];
uint32_t speed = 0;

void i2c2IntProc(){
	static uint8_t recIdx = 0;
	if(LL_I2C_IsActiveFlag_ADDR(I2C2)){
		if(LL_I2C_GetAddressMatchCode(I2C2) == SLAVE_OWN_ADDRESS){
			if(LL_I2C_GetTransferDirection(I2C2) == LL_I2C_DIRECTION_READ){
				while(1);
			} else {
				LL_I2C_ClearFlag_ADDR(I2C2);
			}
		}
	} else if(LL_I2C_IsActiveFlag_RXNE(I2C2)){
		while(LL_I2C_IsActiveFlag_RXNE(I2C2))
			dataSend[recIdx++] = LL_I2C_ReceiveData8(I2C2);
	} else if(LL_I2C_IsActiveFlag_STOP(I2C2)){
		LL_I2C_ClearFlag_STOP(I2C2);
		recIdx = 0;
	} else {
		while(1);
	}
}

void btnIntProc(){
	LL_GPIO_TogglePin(LD2_GPIO_Port, LD2_Pin);
	speed += 0x0FFF/16;
	if(speed > 0x0FFF)
		speed = 0x0FFF;
	dataSend[0] = speed >> 8;
	dataSend[1] = speed;
	dataSend[2] = dataSend[0] + dataSend[1];
}

void run(){
	//Slave Init
	LL_I2C_SetOwnAddress1(I2C2, SLAVE_OWN_ADDRESS, LL_I2C_OWNADDRESS1_7BIT);
	LL_I2C_EnableOwnAddress1(I2C2);
	LL_I2C_EnableIT_ADDR(I2C2);
	LL_I2C_EnableIT_RX(I2C2);
	LL_I2C_EnableIT_STOP(I2C2);
	LL_I2C_Enable(I2C2);

	LL_I2C_Enable(I2C1);
	while (1){
		LL_I2C_HandleTransfer(I2C1, SLAVE_OWN_ADDRESS, LL_I2C_ADDRSLAVE_7BIT, 3,
			LL_I2C_MODE_AUTOEND, LL_I2C_GENERATE_START_WRITE);

		int idx = 0;
		while(!LL_I2C_IsActiveFlag_STOP(I2C1)){
			if(LL_I2C_IsActiveFlag_TXIS(I2C1)){
				LL_I2C_TransmitData8(I2C1, dataSend[idx++]);
			}
		}
		LL_I2C_ClearFlag_STOP(I2C1);

		LL_mDelay(1);
	}
}